//
// MICROCHIP SOFTWARE NOTICE AND DISCLAIMER: You may use this software,
// and any derivatives created by any person or entity by or on your
// behalf, exclusively with Microchip's products. Microchip and its
// licensors retain all ownership and intellectual property rights in
// the accompanying software and in all derivatives hereto.
//
// This software and any accompanying information is for suggestion
// only. It does not modify Microchip's standard warranty for its
// products. You agree that you are solely responsible for testing the
// software and determining its suitability. Microchip has no obligation
// to modify, test, certify, or support the software.
//
// THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES,
// WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO,
// IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS
// FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE, ITS INTERACTION WITH
// MICROCHIP'S PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN
// ANY APPLICATION.
//
// IN NO EVENT, WILL MICROCHIP BE LIABLE, WHETHER IN CONTRACT, WARRANTY,
// TORT (INCLUDING NEGLIGENCE OR BREACH OF STATUTORY DUTY), STRICT
// LIABILITY, INDEMNITY, CONTRIBUTION, OR OTHERWISE, FOR ANY INDIRECT,
// SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS,
// DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE
// SOFTWARE, HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE
// POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
// ALLOWABLE BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY
// WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF
// ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
//
// MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE
// OF THESE TERMS.
//

#if !defined(__CONFIG_H)
#define __CONFIG_H

    #define     CLOCK_FREQ          _XTAL_FREQ
    #define     RAW_DATA_RATE       10000ul



#define DATA_RATE_ADJUST        (5000ul*120/RAW_DATA_RATE)

#if(CLOCK_FREQ <= 4000000ul)

    #define TIMER_CONFIG        0x08
    #define CLOCK_ADJUST        (CLOCK_FREQ/40000ul)
    #define TIMER_DEFAULT       (0xFF - (unsigned char)(DATA_RATE_ADJUST*CLOCK_ADJUST/200))

#elif(CLOCK_FREQ <= 8000000ul)

    #define TIMER_CONFIG        0x08
    #define CLOCK_ADJUST        (CLOCK_FREQ/80000ul)
    #define TIMER_DEFAULT       (0xFF - (unsigned char)(DATA_RATE_ADJUST*CLOCK_ADJUST/100))

#elif(CLOCK_FREQ <= 16000000ul)

    #define TIMER_CONFIG        0x00
    #define CLOCK_ADJUST        (CLOCK_FREQ/160000ul)
    #define TIMER_DEFAULT       (0xFF - (unsigned char)(DATA_RATE_ADJUST*CLOCK_ADJUST/100))

#elif(CLOCK_FREQ <= 32000000ul)

    #define TIMER_CONFIG        0x01
    #define CLOCK_ADJUST        (CLOCK_FREQ/320000ul)
    #define TIMER_DEFAULT       (0xFF - (unsigned char)(DATA_RATE_ADJUST*CLOCK_ADJUST/100))

#elif(CLOCK_FREQ <= 64000000ul)

    #define TIMER_CONFIG        0x02
    #define CLOCK_ADJUST        (CLOCK_FREQ/640000ul)
    #define TIMER_DEFAULT       (0xFF - (unsigned char)(DATA_RATE_ADJUST*CLOCK_ADJUST/100))

#endif




#endif

