//
// MICROCHIP SOFTWARE NOTICE AND DISCLAIMER: You may use this software,
// and any derivatives created by any person or entity by or on your
// behalf, exclusively with Microchip's products. Microchip and its
// licensors retain all ownership and intellectual property rights in
// the accompanying software and in all derivatives hereto.
//
// This software and any accompanying information is for suggestion
// only. It does not modify Microchip's standard warranty for its
// products. You agree that you are solely responsible for testing the
// software and determining its suitability. Microchip has no obligation
// to modify, test, certify, or support the software.
//
// THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES,
// WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO,
// IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS
// FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE, ITS INTERACTION WITH
// MICROCHIP'S PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN
// ANY APPLICATION.
//
// IN NO EVENT, WILL MICROCHIP BE LIABLE, WHETHER IN CONTRACT, WARRANTY,
// TORT (INCLUDING NEGLIGENCE OR BREACH OF STATUTORY DUTY), STRICT
// LIABILITY, INDEMNITY, CONTRIBUTION, OR OTHERWISE, FOR ANY INDIRECT,
// SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS,
// DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE
// SOFTWARE, HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE
// POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
// ALLOWABLE BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY
// WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF
// ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
//
// MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE
// OF THESE TERMS.
//

/** TMR0 Interrrupt routine. Receives incoming trasnmission */
void rxi(void);
/** Initalizes receiver routine */
void InitReceiver(void);

//defines
#define	KeeLoq	1
#define	AES		2
#define	XTEA	3
enum ENCODER
{
	KEELOQ_PACKET = 1,
	AES_PACKET = 2,
    XTEA_PACKET = 3,
};


#define DEFAULT_TMR0    0xAC    // This will give a 60us default int rate

#define KNBIT          65       // Number of bits for Keeloq - 1
#define XNBIT		  100       // Number of bits for XTEA -1 104
#define ANBIT	   	  160       // Number of bits for AES - 1 176

#define TRFreset    	0       // State table defines
#define TRFSYNC     	1
#define TRFUNO      	2
#define TRFZERO     	3
#define TRFSYNC0		4

/** Longest high Te */
#define HIGH_TO     	7
/** Longest low Te */
#define LOW_TO       	7
/** Shortest Thead accepted */
#define SHORT_HEAD   	25
/** Longest Thead accepted */
#define LONG_HEAD    	45

//--------------------------------------------------------------------
// External Variable Definitions
//--------------------------------------------------------------------
extern uint8_t  RX_Buffer[]; // Receive buffer
extern uint8_t RFstate; // Receiver state
extern int8_t RFcount; // Timer counter
extern uint8_t Bptr; // Receive buffer pointer
extern uint8_t BitCount; // Received bits counter
extern uint16_t XTMR; // 16 bit extended timer
extern bit RFsynch; // High level detect prior to synch pulse
extern bit RFFull; // Buffer full
extern bit RFBit; // Sampled RF signal
extern uint8_t RFtype; // Determines what type of encrypted signal

//**********************************************************************
//  End of File : KeeLoq_RX.H
//*********************************************************************
