//
// MICROCHIP SOFTWARE NOTICE AND DISCLAIMER: You may use this software,
// and any derivatives created by any person or entity by or on your
// behalf, exclusively with Microchip's products. Microchip and its
// licensors retain all ownership and intellectual property rights in
// the accompanying software and in all derivatives hereto.
//
// This software and any accompanying information is for suggestion
// only. It does not modify Microchip's standard warranty for its
// products. You agree that you are solely responsible for testing the
// software and determining its suitability. Microchip has no obligation
// to modify, test, certify, or support the software.
//
// THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES,
// WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO,
// IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS
// FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE, ITS INTERACTION WITH
// MICROCHIP'S PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN
// ANY APPLICATION.
//
// IN NO EVENT, WILL MICROCHIP BE LIABLE, WHETHER IN CONTRACT, WARRANTY,
// TORT (INCLUDING NEGLIGENCE OR BREACH OF STATUTORY DUTY), STRICT
// LIABILITY, INDEMNITY, CONTRIBUTION, OR OTHERWISE, FOR ANY INDIRECT,
// SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS,
// DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE
// SOFTWARE, HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE
// POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
// ALLOWABLE BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY
// WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF
// ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
//
// MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE
// OF THESE TERMS.
//

#ifndef __KEELOQ_H
#define __KEELOQ_H

#include <stdint.h>

//--------------------------------------------------------------------
// LED & LEARN Timings
//--------------------------------------------------------------------
#define     TOUT        4           //   5 * 64ms = 320ms output delay
// JASON CHANGED TOUT FROM '4' TO ZERO, TO AVOID HAVING A FLASH IN/OUT FROM 1938 TO 1933
// AS ABOVE
// AS ABOVE
// AS ABOVE
// NOTE NOTE NOTE
#define     TFLASH      5           //   4 * 64ms = 256ms half period
// AS ABOVE, AND 5 TO 10
#define     TLEARN      255         // 255 * 64ms =  16s  learn timeout // ORIGINALLY 255

//----------------- flags defines ------------------------------------
extern bit FHopOK;
extern bit FSame;
extern bit FLearn;
extern bit F2Chance;
extern bit RFFull;
extern bit RFBit;
extern bit RFsynch;

extern uint8_t Buffer[22];
extern uint8_t RX_Buffer[22];
extern uint8_t SEED[4];
extern uint16_t NextHop;
extern uint8_t COut;
extern uint8_t FCode;
extern uint16_t XTMR;
extern uint8_t CLearn, CTLearn;
extern uint8_t CFlash, CTFlash;
extern uint16_t Dato;
extern uint16_t Ind;
extern uint16_t Hop;
extern uint16_t Hop1;
extern uint16_t EHop;
extern uint16_t EHop1;
extern uint16_t ETemp;
extern uint16_t ETemp1;

#endif