//
// MICROCHIP SOFTWARE NOTICE AND DISCLAIMER: You may use this software,
// and any derivatives created by any person or entity by or on your
// behalf, exclusively with Microchip's products. Microchip and its
// licensors retain all ownership and intellectual property rights in
// the accompanying software and in all derivatives hereto.
//
// This software and any accompanying information is for suggestion
// only. It does not modify Microchip's standard warranty for its
// products. You agree that you are solely responsible for testing the
// software and determining its suitability. Microchip has no obligation
// to modify, test, certify, or support the software.
//
// THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES,
// WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO,
// IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS
// FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE, ITS INTERACTION WITH
// MICROCHIP'S PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN
// ANY APPLICATION.
//
// IN NO EVENT, WILL MICROCHIP BE LIABLE, WHETHER IN CONTRACT, WARRANTY,
// TORT (INCLUDING NEGLIGENCE OR BREACH OF STATUTORY DUTY), STRICT
// LIABILITY, INDEMNITY, CONTRIBUTION, OR OTHERWISE, FOR ANY INDIRECT,
// SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS,
// DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE
// SOFTWARE, HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE
// POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
// ALLOWABLE BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY
// WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF
// ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
//
// MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE
// OF THESE TERMS.
//

#include "includes.h"

uint8_t aux;
uint8_t DKEY[8];

void Decrypt(void) {
    unsigned char i, j, key, aux;
    signed char p;

    p = 1;

    for (j = 66; j > 0; j--)
    {
        key = DKEY[p--];
        if (p < 0)
            p += 8;
        for (i = 8; i > 0; i--) {
            // NLF
            if (BIT_TEST(Buffer[3], 6)) {
                if (!BIT_TEST(Buffer[3], 1))
                    aux = 0b00111010; // 10
                else
                    aux = 0b01011100; // 11
            } else {
                if (!BIT_TEST(Buffer[3], 1))
                    aux = 0b01110100; // 00
                else
                    aux = 0b00101110; // 01
            }

            // move bit in position 7
            if (BIT_TEST(Buffer[2], 3))
                aux = (aux << 4) | (aux >> 4);
            if (BIT_TEST(Buffer[1], 0))
                aux <<= 2;
            if (BIT_TEST(Buffer[0], 0))
                aux <<= 1;

            // xor with Buffer and Dkey
            aux ^= Buffer[1] ^ Buffer[3] ^ key;

            Buffer[3] = (Buffer[3] << 1) | (Buffer[2] >> 7);
            Buffer[2] = (Buffer[2] << 1) | (Buffer[1] >> 7);
            Buffer[1] = (Buffer[1] << 1) | (Buffer[0] >> 7);
            Buffer[0] = (Buffer[0] << 1) | (aux >> 7);

            // rotate Dkey
            key <<= 1;
        } // for i
    } // for j
} // decrypt 
